!RENAME 1 !ARG 1  #CHANGE 1 TO 2 OR 3 FOR OTHER PATHS
Multivariate Sire & Dam 
!DOPATH $1 
tag
sire   92 !I
dam  3561 !I
grp    49
sex
brr     4
litter 4871
age 
wwt   !M0 # !M0 identifies missing values
ywt   !M0    
gfw   !M0 
fdm   !M0 
fat   !M0
!PATH 1 
coop.fmt   
!PATH 2  
coop.fmt !CONTINUE coopmf1.rsv # uses initial values from previous .rsv file
!PATH 3  
coop.fmt !CONTINUE coopmf2.rsv

!PATH 0
!SUBSET TrDam123 Trait 1 2 3 0 0
!SUBSET TrLit1234 Trait 1 2 3 4 0
!SUBSET TrAG1245 Trait 1 2 4 5
!SUBSET TrSG123 Trait 1 2 3 0 0

#USING !ASSIGN TO MAKE SPECIFICATION CLEARER
#ASSIGN SIRE DAM  LITTER AND RESIDUAL INITIAL VALUES FROM UNIVARIATE ANALYSES
!ASSIGN SDIAGI !INIT 0.608 1.298 0.015 0.197 0.035 #Initial sire variances
!ASSIGN DDIAGI !INIT 2.2 4.14 0.018
!ASSIGN LDIAGI !INIT 3.74 0.97 0.019 0.941
!ASSIGN RUSI !< !INIT 9.27 0.0 16.48 0.0 0.0 0.14
0.0 0.0 0.0 3.37 0.0 0.0 0.0 0.0 1.14 !>


!ASSIGN VARF !<
 diag(TrAG1245 !INIT 0.0024 0.0019 0.0020 0.00026).age.grp,
    diag(TrSG123   !INIT 0.93 16.0 0.28).sex.grp    !>
 


!PART 1 #DIAGONAL FOR SIRE DAM AND LITTER UNSTRUCTURED FOR RESIDUAL
wwt ywt gfw fdm fat  ~ Trait Trait.age Trait.brr Trait.sex Trait.age.sex !r $VARF,
diag(Trait $SDIAGI).id(sire) diag(TrDam123  $DDIAGI).id(dam) diag(TrLit1234 $LDIAGI ).id(lit) ,
!f Trait.grp 
residual id(units).us(Trait $RUSI)

!PART 2 #CHANGE DIAGONAL TO XFA1 FOR SIRE DAM AND LITTER 
wwt ywt gfw fdm fat ~ Trait Trait.age Trait.brr Trait.sex Trait.age.sex !r $VARF,
xfa1(Trait).id(sire) xfa1(TrDam123).id(dam) xfa1(TrLit1234).id(lit) ,
!f Trait.grp 
residual id(units).us(Trait)
!PART 3 #CHANGE XFA1 TO UNSTRUCTURED FOR SIRE AND LITTER 
wwt ywt gfw fdm fat ~ Trait Trait.age Trait.brr Trait.sex Trait.age.sex !r $VARF,
us(Trait).id(sire) xfa1(TrDam123).id(dam) us(TrLit1234).id(lit) ,
!f Trait.grp 
residual id(units).us(Trait)



!PART 3

VPREDICT !DEFINE
#USING !ASSIGN TO GIVE CONCISE VPREDICT
!ASSIGN lusT lit;us(TrLit1234) # us(TrLit1234).id(lit);us(TrLit1234)
!ASSIGN susT sire;us(Trait) #us(Trait).id(sire);us(Trait)
!ASSIGN uusT id(units).us(Trait);us(Trait)
X Damv  xfa1(TrDam123) # defines 54:59
F phen $uusT[1:6]+$susT[1:6]+$lusT[1:6]+xfa1(TrDam123)
# defines [1:6] elements of phen 
# defines 60:65=          1:6 +             23:28 +                 44:49 + 54:59 
F phen   $uusT[7:10]+$susT[7:10]+ $lusT[7:10]
# defines [7:10] elements of phen
# defines 66:69=         7:10 +              29:32 +                  50:53 
F phen   $uusT[11:15]+$susT[11:15]
# defines [11:15] elements of phen
# defines 70:74=         11:15 +               33:37 
F Direct  $susT *4.                #defines  75: 89= 23:37 * 4. 
F Maternal Damv -$susT[1:6]       #defines  90: 95= 54:59 - 23:28   
F resid phen - $susT      #defines  96:110= 60:74 - 23-37
H WWTh2 Direct[1]  phen[1]  #defines 111= 75/ 60
H YWTh2 Direct[3]  phen[3]  #defines 112= 77/ 62
H GFWh2 Direct[6]  phen[6]  #defines 113= 80/ 65
H FDMh2 Direct[10] phen[10]    #defines 114= 84/ 69
H FATh2 Direct[15] phen[15]    #defines 115= 89/ 74
R GenCor $susT        #defines 116:125 from 23:37
R MatCor Maternal              #defines 126:129 from 90:95
